clear all; close all; clc

% load APMonitor library
addpath('apm')

% Set up problem
s = 'http://byu.apmonitor.com';
a = '2nd_order';
apm(s,a,'clear all');
apm_load(s,a,'2nd_order.apm');
csv_load(s,a,'2nd_order.csv');
apm_option(s,a,'nlc.imode',5);
apm_option(s,a,'nlc.nodes',3);
apm_info(s,a,'MV','c');
apm_option(s,a,'c.status',1);
apm_option(s,a,'c.dcost',1e-5);
apm_option(s,a,'c.mv_step_hor',10);

% Estimate parameters
output = apm(s,a,'solve');
disp(output)
y = apm_sol(s,a); z = y.x;

% plot results
figure(1)
subplot(2,1,1)
plot(z.time,z.y,'r-','LineWidth',3)
hold on
plot(z.time,z.ym,'b.')
plot(z.time,z.dy,'b--','linewidth',2)
legend('y (Predicted)','y (Measured)','dy/dt')
subplot(2,1,2)
time = linspace(0,2,50);
c = (0.9+0.7*time);
plot(z.time,z.c,'k--','LineWidth',2)
hold on
plot(time,c,'r:','LineWidth',2)
legend('Estimated c','Actual c')
xlabel('Time')
